One design pattern I used was to restrict access using modifiers to some functionality of the app. This design pattern helps to prevent users from using functions they are not/should not be using since MetaMask will display an error loud and clearly before the user has the chance to submit the function. This also provide and extra layer of logic to prevent any mistakes in access priveleges during development. When developing the withdrawal functionality I was sure to prevent any reentrancy and underflow/overflow attacks.

